/*
 * proto.h -- prototypes for library functions.
 */

/*
 * The following code is operating-system dependent. [@proto.01].
 *  Prototypes for library functions.
 */

#if PORT
Deliberate Syntax Error
#endif					/* PORT */

#if AMIGA
#if LATTICE
#include <dos.h>
#endif					/* LATTICE */
/* ****  TEMPORARY *** */
novalue	_exit		Params((int));
novalue	abort		Params((noargs));
double	atof		Params((char *));
long	atol		Params((char *));
pointer	calloc		Params((unsigned,unsigned));
int	execv		Params((char *, char **));
int	execvp		Params((char *, char **));
novalue	exit		Params((int));
char	*getenv		Params((char *));
char	*getmem		Params((unsigned));
char	*index		Params((char *s, int c));
pointer	malloc		Params((msize));
pointer	realloc		Params((pointer, unsigned));
char	*strchr		Params((char *s, int i));
int	strcmp		Params((char *s1, char *s2));
char	*strcpy		Params((char *s1, char *s2));
char	*strncat	Params((char *s1, char *s2, int n));
int	strncmp		Params((char *s1, char *s2, int n));
char	*strncpy	Params((char *s1, char *s2, int n));
#ifdef SystemFnc
int	system		Params((char *));
#endif					/* SystemFnc */
#endif					/* AMIGA */

#if ARM
#include <stdlib.h>
#include <string.h>

/* Our verson of unlink, which will fail if the named file does not exist */
extern int unlink (const char *name);

/* Force a cast of the function parameter to qsort() */
#define	qsort(base,n,size,cmp) \
	(qsort)((base),(n),(size),(int (*) (const void *, const void *))(cmp))
#endif					/* ARM */

#if HIGHC_386
#include <stdlib.h>
#include <string.h>
#endif					/* HIGHC_386 */

#if MACINTOSH
#if MPW
#include <stdlib.h>
#include <string.h>
#else					/* MPW */
novalue	_exit		Params((int));
novalue	abort		Params((noargs));
double	atof		Params((char *));
long	atol		Params((char *));
pointer	calloc		Params((unsigned,unsigned));
int	execv		Params((char *, char **));
int	execvp		Params((char *, char **));
novalue	exit		Params((int));
char	*getenv		Params((char *));
char	*getmem		Params((unsigned));
char	*index		Params((char *s, int c));
pointer	malloc		Params((msize));
pointer	realloc		Params((pointer, unsigned));
char	*strchr		Params((char *s, int i));
int	strcmp		Params((char *s1, char *s2));
char	*strcpy		Params((char *s1, char *s2));
char	*strncat	Params((char *s1, char *s2, int n));
int	strncmp		Params((char *s1, char *s2, int n));
char	*strncpy	Params((char *s1, char *s2, int n));
#ifdef SystemFnc
int	system		Params((char *));
#endif					/* SystemFnc */
#endif					/* MPW */
#endif					/* MACINTOSH */

#if MSDOS
#include <dos.h>
#ifdef StandardLib
#include <string.h>
#include <stdlib.h>
#else					/* StandardLib */
novalue	_exit		Params((int));
novalue	abort		Params((noargs));
double	atof		Params((char *));
long	atol		Params((char *));
pointer	calloc		Params((unsigned,unsigned));
int	execv		Params((char *, char **));
int	execvp		Params((char *, char **));
novalue	exit		Params((int));
char	*getenv		Params((char *));
char	*getmem		Params((unsigned));
char	*index		Params((char *s, int c));
pointer	malloc		Params((msize));
pointer	realloc		Params((pointer, unsigned));
char	*strchr		Params((char *s, int i));
int	strcmp		Params((char *s1, char *s2));
char	*strcpy		Params((char *s1, char *s2));
char	*strncat	Params((char *s1, char *s2, int n));
int	strncmp		Params((char *s1, char *s2, int n));
char	*strncpy	Params((char *s1, char *s2, int n));
#ifdef SystemFnc
int	system		Params((char *));
#endif					/* SystemFnc */
#endif					/* StandardLib */
#endif					/* MSDOS */

#if OS2
#include <dos.h>
#ifdef StandardLib
#include <string.h>
#include <stdlib.h>
#else					/* StandardLib */
/* ****  TEMPORARY *** */
novalue _exit		Params((int));
novalue abort		Params((noargs));
double	atof		Params((char *));
long	atol		Params((char *));
pointer calloc		Params((unsigned,unsigned));
int	execv		Params((char *, char **));
int	execvp		Params((char *, char **));
novalue exit		Params((int));
char	*getenv 	Params((char *));
char	*getmem 	Params((unsigned));
pointer malloc		Params((msize));
pointer realloc 	Params((pointer, unsigned));
char	*strchr 	Params((char *s, int i));
int	strcmp		Params((char *s1, char *s2));
char	*strcpy 	Params((char *s1, char *s2));
char	*strncat	Params((char *s1, char *s2, int n));
int	strncmp 	Params((char *s1, char *s2, int n));
char	*strncpy	Params((char *s1, char *s2, int n));
#ifdef SystemFnc
int	system		Params((char *));
#endif					/* SystemFnc */
#endif					/* StandardLib */
#endif					/* OS2 */

#if UNIX
#ifdef StandardLib
#include <stdlib.h>
#include <string.h>
#else					/* StandardLib */
novalue	_exit		Params((int));
novalue	abort		Params((noargs));
double	atof		Params((char *));
long	atol		Params((char *));
char	*getenv		Params((char *));
pointer	calloc		Params((unsigned,unsigned));
int	execv		Params((char *, char **));
int	execvp		Params((char *, char **));
novalue	exit		Params((int));
char	*getmem		Params((unsigned));
char	*index		Params((char *s, int c));
pointer	malloc		Params((msize));
pointer	realloc		Params((pointer, unsigned));
char	*strchr		Params((char *s, int i));
int	strcmp		Params((char *s1, char *s2));
char	*strcpy		Params((char *s1, char *s2));
char	*strncat	Params((char *s1, char *s2, int n));
int	strncmp		Params((char *s1, char *s2, int n));
char	*strncpy	Params((char *s1, char *s2, int n));
#ifdef SystemFnc
int	system		Params((char *));
#endif					/* SystemFnc */
#endif					/* StandardLib */
#endif					/* UNIX */

#if VM || MVS
/* ****  TEMPORARY *** */
novalue abort           Params((noargs));
double  atof            Params((char *));
long    atol            Params((char *));
pointer calloc          Params((unsigned,unsigned));
novalue exit            Params((int));
char    *getenv         Params((char *));
pointer malloc          Params((msize));
pointer realloc         Params((pointer, unsigned));
#ifdef StandardC
#include <string.h>
#else                                   /* StandardC */
char    *strchr         Params((char *s, int i));
int     strcmp          Params((char *s1, char *s2));
char    *strcpy         Params((char *s1, char *s2));
char    *strncat        Params((char *s1, char *s2, int n));
int     strncmp         Params((char *s1, char *s2, int n));
char    *strncpy        Params((char *s1, char *s2, int n));
#ifdef SystemFnc
int	system		Params((char *));
#endif					/* SystemFnc */
#endif                                  /* StandardC */
#endif                                  /* VM || MVS */

#if VMS
/* ****  TEMPORARY *** */
novalue	_exit		Params((int));
novalue	abort		Params((noargs));
double	atof		Params((char *));
long	atol		Params((char *));
pointer	calloc		Params((unsigned,unsigned));
int	execv		Params((char *, char **));
int	execvp		Params((char *, char **));
novalue	exit		Params((int));
char	*getenv		Params((char *));
char	*getmem		Params((unsigned));
char	*index		Params((char *s, int c));
pointer	malloc		Params((msize));
pointer	realloc		Params((pointer, unsigned));
char	*strchr		Params((char *s, int i));
int	strcmp		Params((char *s1, char *s2));
char	*strcpy		Params((char *s1, char *s2));
char	*strncat	Params((char *s1, char *s2, int n));
int	strncmp		Params((char *s1, char *s2, int n));
char	*strncpy	Params((char *s1, char *s2, int n));
#ifdef SystemFnc
int	system		Params((char *));
#endif					/* SystemFnc */
#endif					/* VMS */

/*
 * End of operating-system specific code.
 */

#ifdef KeyboardFncs
int	getch		Params((noargs));
int	getche		Params((noargs));
int	kbhit		Params((noargs));
#endif					/* KeyboardFncs */

#include "../h/cproto.h"

/*
 * There must be after prototypes to avoid clash with system
 * prorotypes.
 */

#if IntBits == 16
#define sbrk lsbrk
#define qsort llqsort
#define strlen lstrlen
#endif					/* IntBits == 16 */
