/*
 * Prototypes for run-time functions.
 */

/*
 * Prototypes common to the compiler and interpreter.
 */

char	*alcstr			Params((char *s,word slen));
char	*ecvt		Params((double value, int count, int *dec, int* sign));
char	*findfile		Params((word *ipc));
char	*icon_gcvt		Params((double number,int ndigit,char *buf));
int	anycmp			Params((dptr dp1,dptr dp2));
int	bfunc		Params((noargs));
int	cplist			Params((dptr dp1,dptr dp2,word i,word j));
int	csetcmp			Params((unsigned int *cs1,unsigned int *cs2));
int	cvstr			Params((dptr dp,char *sbuf));
int	defcset			Params((dptr dp,int * *cp,int *buf,int *def));
int	deffile			Params((dptr dp,dptr def));
int	defint			Params((dptr dp,long *lp,word def));
int	defshort		Params((dptr dp,int def));
int	defstr			Params((dptr dp,char *buf,dptr def));
int	deref			Params((dptr dp));
int	doasgn			Params((dptr dp1,dptr dp2));
int	doimage			Params((int c,int q));
int	equiv			Params((dptr dp1,dptr dp2));
int	err			Params((noargs));
int	findipc			Params((int line));
int	findline		Params((word *ipc));
int	getimage		Params((dptr dp1, dptr dp2));
int	getstrg			Params((char *buf,int maxi,FILE *fd));
int	invoke			Params((int nargs,dptr  *cargp,int *n));
int	lexcmp			Params((dptr dp1,dptr dp2));
int	numcmp			Params((dptr dp1,dptr dp2,dptr dp3));
int	pushact	Params((struct b_coexpr *ce, struct b_coexpr *actvtr));
int	putstr			Params((FILE *f,dptr d));
int	qlcmp			Params((dptr  *q1,dptr  *q2));
int	rtos			Params((double n,dptr dp,char *s));
novalue	addmem 	Params((struct b_set *ps,struct b_selem *pe, union block **pl));
novalue	adjust			Params((char *source,char *dest));
novalue	c_exit			Params((int i));
novalue	cofree			Params((noargs));
novalue	compact			Params((char *source));
novalue	datainit		Params((noargs));
novalue	env_int	Params((char *name,word *variable,int non_neg, uword limit));
novalue	envset			Params((noargs));
novalue	error			Params((char *s));
novalue	fatalerr		Params((int n,dptr v));
novalue	fixtrap			Params((noargs));
novalue	fpetrap			Params((noargs));
novalue	iconhost		Params((char *hostname));
novalue	initalloc		Params((word codesize));
novalue	markblock		Params((dptr dp));
novalue	markptr			Params((union block **));
novalue	mksubs	Params((dptr var,dptr val,word i,word j, dptr result));
novalue	mvc			Params((uword n,char *src,char *dest));
novalue	outimage		Params((FILE *f,dptr dp,int restrict));
novalue	postqual		Params((dptr dp));
novalue	resolve			Params((noargs));
novalue	runerr			Params((int n,dptr v));
novalue	scollect		Params((word extra));
novalue	segvtrap		Params((noargs));
novalue	stkdump			Params((int));
novalue	sweep			Params((struct b_coexpr *ce));
novalue	syserr			Params((char *s));
novalue	xdisp	Params((struct pf_marker *fp,dptr dp,int count, FILE *f));
novalue	xtrace	Params((struct b_proc *bp,word nargs,dptr arg, int pline,char *pfile));
struct	astkblk *alcactiv	Params((noargs));
struct	b_coexpr *popact	Params((struct b_coexpr *ce));
struct	b_coexpr *topact	Params((struct b_coexpr *ce));
struct	b_cset *alccset		Params((noargs));
struct	b_file *alcfile		Params((FILE *fd,int status,dptr name));
struct	b_lelem *alclstb	Params((uword nslots,uword first,uword nused));
struct	b_list *alclist		Params((uword size));
struct	b_real *alcreal		Params((double val));
struct	b_record *alcrecd	Params((int nflds,union block **recptr));
struct	b_refresh *alcrefresh	Params((word *entryx,int na,int nl));
struct	b_selem *alcselem	Params((dptr mbr,uword hn));
struct	b_telem *alctelem	Params((noargs));
struct	b_tvtbl *alctvtbl	Params((dptr tbl,dptr ref,uword hashnum));
word	cvpos			Params((long pos,long len));
word	longread		Params((char *s,int width,long len,FILE *fname));
word	prescan			Params((dptr d));

#if !HIGHC_386
int	dup2		Params((int h1, int h2));
#endif					/* !HIGHC_386 */

#if IntBits == 16
novalue	llqsort		Params((char *base, int nel, int width, int (*cmp)()));
#endif					/* IntBits == 16 */

#if !(MACINTOSH && MPW)
double pow();			/* prototype problem */
#endif					/* !(MACINTOSH && MPW) */

/*
 * Temporary fix
 */

#if ARM
FILE *popen

#endif					/* ARM */
#if ATARI_ST
char	*sbrk			Params((int incr));
#endif                                  /* ATARI_ST */

#if HIGHC_386
int	brk		Params((char *p));
char	*sbrk		Params((int n));
#endif					/* HIGHC_386 */

#if MACINTOSH
#if MPW
char	*brk			Params((char *addr));
char	*sbrk			Params((int incr));
novalue	free			Params((char* addr));
#endif					/* MPW */
#endif					/* MACINTOSH */

#if MVS || VM
#if SASC
#define brk(x) sbrk(((char *)(x))-sbrk(0))
char    *sbrk                   Params((int incr));
#endif					/* SASC */
novalue free                    Params((void* addr));
#endif                                  /* MVS || VM */

#if UNIX || VMS
char	*brk			Params((char *addr));
int	chdir			Params((char *path));
FILE	*popen			Params((char * command, char *type));
char	*sbrk			Params((int incr));
#endif                                  /* UNIX || VMS */


#ifdef LargeInts
struct	b_bignum *alcbignum	Params((word n));
word	bigradix		Params((int sign, int r, char *s, dptr dx));
double	bigtoreal		Params((dptr da));
int	realtobig		Params((dptr da, dptr dx));
int	bigtos			Params((dptr da, dptr dx));
novalue	bigprint		Params((FILE *f, dptr da));
int	cpbignum		Params((dptr da, dptr db));
int	bigadd			Params((dptr da, dptr db, dptr dx));
int	bigsub			Params((dptr da, dptr db, dptr dx));
int	bigmul			Params((dptr da, dptr db, dptr dx));
int	bigdiv			Params((dptr da, dptr db, dptr dx));
int	bigmod			Params((dptr da, dptr db, dptr dx));
int	bigneg			Params((dptr da, dptr dx));
int	bigpow			Params((dptr da, dptr db, dptr dx));
int	bigand			Params((dptr da, dptr db, dptr dx));
int	bigor			Params((dptr da, dptr db, dptr dx));
int	bigxor			Params((dptr da, dptr db, dptr dx));
int	bigshift		Params((dptr da, dptr db, dptr dx));
word	bigcmp			Params((dptr da, dptr db));
int	bigrand			Params((dptr da, dptr dx));
#endif					/* LargeInts */


#if COMPILER

/*
 * Prototypes for the compiler run-time system.
 */

C_integer	iipow	Params((C_integer n1, n2));
C_integer	nxttab	Params((C_integer col, dptr *tablst, dptr endlst, C_integer *last, C_integer *interval));
double	ipow	Params((double r, C_integer n));
double  ripow    		Params((double r, C_integer n));
int	bfunc	Params((noargs));
int	co_chng	Params((struct b_coexpr *ncp, struct descrip *valloc, struct descrip *rsltloc, int swtch_typ, int first));
int	collect	Params((int region, word nbytes, int err_ret));
int	coswitch	Params((word *old, word *new, continuation fnc));
int	cvcset	Params((dptr dp,int * *cs,int *csbuf));
int	cvint	Params((dptr dp,long *i));
int	cvnum	Params((dptr dp,union numeric *result));
int	cvreal	Params((dptr dp,double *r));
int	derefence	Params((dptr dp));
int	envset	Params((noargs));
int	eq	Params((dptr dp1,dptr dp2));
int	fixtrap	Params((noargs));
int	getname	Params((dptr dp1, dptr dp2));
int	getstrg	Params((char *buf,int maxi,FILE *fd));
int	locate	Params((struct b_selem *ep,struct b_selem *obj));
int	mkreal	Params((double r,dptr dp));
int	order	Params((dptr dp));
int	printable	Params((int c));
int	sig_rsm	Params((noargs));
int	trcmp3	Params((struct dpair *dp1,struct dpair *dp2));
int	trefcmp	Params((dptr d1,dptr d2));
int	tvalcmp	Params((dptr d1,dptr d2));
int	tvcmp4	Params((struct dpair *dp1,struct dpair *dp2));
long	ckadd	Params((long i, long j));
long	ckmul	Params((long i, long j));
long	cksub	Params((long i, long j));
novalue	atrace	Params((noargs));
novalue	cmd_line	Params((int argc, char **argv, dptr rslt));
novalue	co_init	Params((struct b_coexpr *sblkp));
novalue	cotrace	Params((struct b_coexpr *ccp, struct b_coexpr *ncp, int swtch_typ, dptr valloc));
novalue	cplist	Params((dptr dp1,dptr dp2,word i,word j));
novalue	ctrace	Params((noargs));
novalue	failtrace	Params((noargs));
novalue	init	Params((char *name));
novalue	rtrace	Params((noargs));
novalue	strace	Params((noargs));
novalue	subs_asgn	Params((dptr dest, dptr src));
novalue	tracebk	Params((struct p_frame *pfp, struct descrip *argp, char *file_name, int line_num));
novalue	tvtbl_asgn	Params((dptr dest, dptr src));
novalue	varargs	Params((dptr argp, int nargs, dptr rslt));
pointer	memcpy	Params((char *dest,char *src, int c));
struct	b_coexpr *alccoexp	Params((noargs));
struct	b_coexpr *create   Params((continuation fnc, int ntemps, int wrk_size));
struct	b_set *alcset		Params((noargs));
struct	b_external *alcextrnl	Params((int n));
struct	b_proc *strprc	Params((dptr s, C_integer arity));
struct	b_table *alctable	Params((dptr def));
struct	b_tvsubs *alcsubs	Params((word len,word pos,dptr var));
union	block *memb	Params((struct b_set *ps,dptr x,word hn, int *res));
union	block *memb_tbl	Params((struct b_table *pt,dptr x,word hn, int *res));
word	hash	Params((dptr dp));

#ifdef MemMon
novalue	MMInit	Params((char *name));
novalue	MMTerm	Params((char *part1, char *part2));
novalue	MMAlc	Params((word len, int type));
novalue	MMBGC	Params((int region));
novalue	MMEGC	Params((noargs));
novalue	MMMark	Params((char *block, int type));
novalue	MMShow	Params((dptr dp, char *s));
novalue	MMStat	Params((char *a, word n, int c));
novalue	MMStr	Params((word slen));
novalue	MMSMark	Params((char *saddr, word slen));
#endif		/* MemMon */

#else					/* COMPILER */

/*
 * Prototypes for the interpreter run-time system.
 */

#define Fargs dptr cargp

dptr	icon_call		Params((char *s, int argc, dptr dp));
int	coswitch	Params((word *old, word *new, int first));
int	Obscan			Params((int nargs,Fargs));
int	Ocreate			Params((word *entryp,Fargs));
int	Oescan			Params((int nargs,Fargs));
int	Ofield			Params((int nargs,Fargs));
int	Okeywd			Params((int nargs,Fargs));
int	Olimit			Params((int nargs,Fargs));
int	Ollist			Params((int nargs,Fargs));
int	Omkrec			Params((int nargs,Fargs));
int	blkreq			Params((uword bytes));
int	cpset			Params((dptr dp1,dptr dp2,word size));
int	cvcset			Params((dptr dp,int * *cs,int *csbuf));
int	cvint			Params((dptr dp));
int	cvnum			Params((dptr dp));
int	cvreal			Params((dptr dp));
int	deref			Params((dptr dp));
int	getvar			Params((char *s, dptr dp));
int	keyref			Params((dptr dp1, dptr dp2));
int	makereal		Params((double r,dptr dp));
int	order			Params((dptr dp));
int	putint			Params((dptr dp,struct b_tvkywd *bp));
int	putpos			Params((dptr dp,struct b_tvkywd *bp));
int	putrec			Params((FILE *fd,dptr d));
int	putsub			Params((dptr dp,struct b_tvkywd *bp));
int	qtos			Params((dptr dp,char *sbuf));
int	strprc			Params((dptr dp, word n));
int	strreq			Params((uword n));
long	ipow			Params((long n1,long n2));
novalue	atrace			Params((dptr sptr));
novalue	coacttrace	Params((struct b_coexpr *ccp, struct b_coexpr *ncp));
novalue	cofailtrace	Params((struct b_coexpr *ccp, struct b_coexpr *ncp));
novalue	collect			Params((int region));
novalue	corettrace	Params((struct b_coexpr *ccp, struct b_coexpr *ncp));
novalue	ctrace			Params((dptr sptr,int nargs,dptr arg));
novalue	failtrace		Params((dptr sptr));
novalue	hgrow			Params((dptr dp));
novalue	hshrink			Params((dptr dp));
novalue	icon_init		Params((char *name));
novalue	icon_setup		Params((int argc, char **argv, int *ip));
novalue	inttrap			Params((noargs));
novalue	rtrace			Params((dptr sptr,dptr rval));
novalue	runerr			Params((int n,dptr v));
novalue	scollect		Params((word extra));
novalue	segvtrap		Params((noargs));
novalue	stkdump			Params((int));
novalue	ttrace			Params((noargs));
novalue	xtrace 	Params((struct b_proc *bp,word nargs,dptr arg, int pline,char *pfile));
struct	b_external *alcextrnl	Params((uword n));
struct	b_slots *alcsegment	Params((word nslots));
struct	b_tvsubs *alcsubs	Params((word len,word pos,dptr var));
union	block *alchash		Params((int tcode));
union block **memb	Params((union block *pb,dptr x,uword hn, int *res));
union block **hchain		Params((union block *pb,uword hn));
union block *hmake		Params((int tcode,word nslots,word nelem));
word	add			Params((word a, word b));
uword	hash			Params((dptr dp));
word	sub			Params((word a, word b));
word	mul			Params((word a, word b));
word	neg			Params((word a));

#ifdef MemMon
novalue	EVInit			Params((char *name, char *fname));
novalue EVSetup			Params((noargs));
novalue EVTerm			Params((int n, char *s));
novalue	MMAlc			Params((word len, int type));
novalue	MMBGC			Params((int region));
novalue	MMEGC			Params((noargs));
novalue	MMMark			Params((char *block, int type));
novalue	MMStat			Params((char *a, word n, int c));
novalue	MMShow			Params((dptr dp, char *s));
novalue	MMStr			Params((word slen));
novalue	MMSMark			Params((char *saddr, word slen));
#endif					/* MemMon */


#ifdef EventMon
novalue	EVFnc			Params((word j));
novalue EVInt                   Params((word i));
novalue EVList			Params((word op, word id));
novalue EVNest			Params((word level));
novalue	EVQval			Params((dptr dp, int j));
novalue	EVTick			Params((noargs));
novalue EVUnNest                Params((word level));
novalue	EVVal			Params((word value, int event));
novalue	EVValD			Params((dptr dp, int event));
novalue	EVValX			Params((struct b_coexpr *bp, int event));
novalue	vanquish		Params((struct gf_marker *gfp));
#endif					/* EventMon */

#define FncDef(p,n) int Cat(X,p) 	Params((Fargs));
#define FncDefV(p) int Cat(X,p) 	Params((int nargs,Fargs));
#include "../h/fdefs.h"
#undef FncDef
#undef FncDefV
#define OpDef(p,n,s) int Cat(O,p) 	Params((Fargs));
#include "../h/odefs.h"
#undef OpDef

int	Ahgener			Params((dptr cargp));

struct	b_coexpr *alccoexp	Params((noargs));

#ifdef DeBugIconx
novalue	blkdump			Params((noargs));
novalue	descr			Params((dptr dp));
novalue	dumpact			Params((struct b_coexpr *cw));
#endif					/* DeBugIconx */

#ifdef ExternalFunctions
dptr	extcall			Params((dptr dargv, int argc, int *ip));
#endif					/* ExternalFunctions */


int	interp			Params((int fsig,dptr cargp));

#endif					/* COMPILER */
